
#include "sndlib/io.h"
#include "sndlib/headers.h"
#include "sndlib/sound.h"

#include "funcs/es_funcs.h"
#include "funcs/gen_funcs.h"



void Procesar(DAUDIO *sal, mus_sample_t **sbuf);

int main(int argc, char *argv[])
{
	//DAUDIO *au_sal = NULL;
  mus_sample_t **sbuf;    /* buffer usados para la entrada y salida de las muestras */
	DAUDIO au_sal = {-1, 1, 44100, 88200, 88200, 2, MUS_LSHORT, MUS_RIFF, "escrito por ivn"};

		/* el segundo argumento tiene que ser la salida de audio */
	if(ChequearEntrada(argc, 2, "Lnea de comando: falta nombre de archivo", "sndoscil") == -1)
		{
    getchar();
    return -1;
		}
  mus_sound_initialize();	  /* inicializo sndlib */

	AbrirAudioSalida(argv[1], &au_sal, "\nAUDIO DE SALIDA");   
	if(au_sal.na == -1)
    return -1;
	/* RESERVA DE MEMORIA para el buffer */
	sbuf = SndAsignarMemoria(&au_sal, TAM_BUFFER);

	Procesar(&au_sal, sbuf);

	/* LIBERAR MEMORIA, CERRAR ARCHIVOS */
	SndLiberarMemoria(&au_sal, sbuf);
  close(au_sal.na);
  return 0;
}

void Procesar(DAUDIO *sal, mus_sample_t **sbuf)
{
	int i, k, j;             /* iteradores */
	int tam = TAM_BUFFER;    /* se usa porque 'tam' puede ser modificado */
	float mues;             /* muestra actual modificada */

	float *tseno;
	int largo = 4096;
	OSCIL *oscil;

	tseno = CrearTablaSeno(0.0, largo);
	oscil = IniciarOscilador(largo, 0.0);


	for(i = 0; i < sal->muestras; i += TAM_BUFFER)     /* itera sobre todas las muestras, avanzando cada tamao de buffer */
		{
		for(j = 0; j < sal->canales; j++)                /* itera por cada canal */
			{
			for(k = 0; k < tam; k++)          /* itera hasta el tamao del buffer o hasta que no haya ms muestras */
				{
				if(i + k == sal->muestras)   /* preveo de no pasarme de largo en el arreglo */
					break; 
				mues = ValorActualOscilador(oscil, 440.0, .7, tseno, largo, sal->frec_muestreo);
				sbuf[j][k] = MUS_FLOAT_TO_SAMPLE(mues);  /* guardo la modificacin en la salida */
				}
			}
     if(k != TAM_BUFFER && k != 0) 
				tam = j - 1;
			mus_sound_write(sal->na, 0, tam - 1, sal->canales, sbuf);   /* escribe en archivo de salida */
		}
  mus_sound_close_output(sal->na, sal->muestras * mus_bytes_per_sample(sal->formato));  /* cierro el archivo de salida */
}



